| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GpuProgramUsage Class Reference
Core » Materials

This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit. More...

`#include <OgreGpuProgramUsage.h>`

Inheritance diagram for Ogre::GpuProgramUsage:
[legend]

## Public Member Functions
| GpuProgramUsage (GpuProgramType gptype, Pass *parent)
| Default constructor. More...
| GpuProgramUsage (const GpuProgramUsage &rhs, Pass *newparent)
| Copy constructor. More...
| ~GpuProgramUsage ()
void | _load (void)
| Load this usage (and ensure program is loaded) More...
void | _unload (void)
| Unload this usage. More...
size_t | calculateSize (void) const
const GpuProgramParametersSharedPtr & | getParameters (void) const
| Gets the parameters being used here. More...
const GpuProgramPtr & | getProgram () const
| Gets the program being used. More...
const String & | getProgramName (void) const
| Gets the program being used. More...
GpuProgramType | getType (void) const
| Gets the type of program we're trying to link to. More...
void | loadingComplete (Resource *prog)
| Called whenever the resource finishes loading. More...
virtual void | preparingComplete (Resource *)
| Called whenever the resource finishes preparing (paging into memory). More...
void | setParameters (const GpuProgramParametersSharedPtr &params)
| Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects. More...
void | setProgram (const GpuProgramPtr &prog, bool resetParams=true)
| Sets the program to use. More...
void | setProgramName (const String &name, bool resetParams=true)
| Sets the name of the program to use. More...
void | unloadingComplete (Resource *prog)
| Called whenever the resource has been unloaded. More...

## Static Public Member Functions
static GpuProgramPtr | _getProgramByName (const String &name, const String &group, GpuProgramType type)

## Detailed Description

This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.

Remarks
  Using a vertex or fragment program can get fairly complex; besides the fairly rudimentary process of binding a program to the GPU for rendering, managing usage has few complications, such as:
  - Programs can be high level (e.g. Cg, RenderMonkey) or low level (assembler). Using either should be relatively seamless, although high-level programs give you the advantage of being able to use named parameters, instead of just indexed registers
  - Programs and parameters can be shared between multiple usages, in order to save memory
  - When you define a user of a program, such as a material, you often want to be able to set up the definition but not load / compile / assemble the program at that stage, because it is not needed just yet. The program should be loaded when it is first needed, or earlier if specifically requested. The program may not be defined at this time, you may want to have scripts that can set up the definitions independent of the order in which those scripts are loaded.
  This class packages up those details so you don't have to worry about them. For example, this class lets you define a high-level program and set up the parameters for it, without having loaded the program (which you normally could not do). When the program is loaded and compiled, this class will then validate the parameters you supplied earlier and turn them into runtime parameters.

  Just incase it wasn't clear from the above, this class provides linkage to both GpuProgram and HighLevelGpuProgram, despite its name.

## Constructor & Destructor Documentation

## ◆ GpuProgramUsage() [1/2]

Ogre::GpuProgramUsage::GpuProgramUsage | ( | GpuProgramType | gptype,
|  | Pass * | parent
| ) |  |

Default constructor.

Parameters

  gptype | The type of program to link to

## ◆ GpuProgramUsage() [2/2]

Ogre::GpuProgramUsage::GpuProgramUsage | ( | const GpuProgramUsage & | rhs,
|  | Pass * | newparent
| ) |  |

Copy constructor.

## ◆ ~GpuProgramUsage()

Ogre::GpuProgramUsage::~GpuProgramUsage | ( |  | ) |

## Member Function Documentation

## ◆ getType()

GpuProgramType Ogre::GpuProgramUsage::getType | ( | void |  | ) | const
| inline

Gets the type of program we're trying to link to.

## ◆ setProgramName()

void Ogre::GpuProgramUsage::setProgramName | ( | const String & | name,
|  | bool | resetParams = `true`
| ) |  |

Sets the name of the program to use.

Parameters

  name | The name of the program to use
  resetParams | If true, this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again. If you set this to false, you must be absolutely sure that the parameters match perfectly, and in the case of named parameters refers to the indexes underlying them, not just the names.

## ◆ setProgram()

void Ogre::GpuProgramUsage::setProgram | ( | const GpuProgramPtr & | prog,
|  | bool | resetParams = `true`
| ) |  |

Sets the program to use.

Remarks
  Note that this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again.

## ◆ getProgram()

const GpuProgramPtr& Ogre::GpuProgramUsage::getProgram | ( |  | ) | const
| inline

Gets the program being used.

## ◆ getProgramName()

const String& Ogre::GpuProgramUsage::getProgramName | ( | void |  | ) | const
| inline

Gets the program being used.

References Ogre::Resource::getName().

## ◆ setParameters()

void Ogre::GpuProgramUsage::setParameters | ( | const GpuProgramParametersSharedPtr & | params | ) |

Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects.

Otherwise, the parameters will be created for you when a program is linked.

## ◆ getParameters()

const GpuProgramParametersSharedPtr& Ogre::GpuProgramUsage::getParameters | ( | void |  | ) | const

Gets the parameters being used here.

## ◆ _load()

void Ogre::GpuProgramUsage::_load | ( | void |  | ) |

Load this usage (and ensure program is loaded)

## ◆ _unload()

void Ogre::GpuProgramUsage::_unload | ( | void |  | ) |

Unload this usage.

## ◆ calculateSize()

size_t Ogre::GpuProgramUsage::calculateSize | ( | void |  | ) | const

## ◆ unloadingComplete()

void Ogre::GpuProgramUsage::unloadingComplete | ( | Resource * |  | ) |
| virtual

Called whenever the resource has been unloaded.

Reimplemented from Ogre::Resource::Listener.

## ◆ loadingComplete()

void Ogre::GpuProgramUsage::loadingComplete | ( | Resource * |  | ) |
| virtual

Called whenever the resource finishes loading.

Remarks
  If a Resource has been marked as background loaded (

See also
  Resource::setBackgroundLoaded), the call does not itself occur in the thread which is doing the loading; when loading is complete a response indicator is placed with the ResourceGroupManager, which will then be sent back to the listener as part of the application's primary frame loop thread.

Reimplemented from Ogre::Resource::Listener.

## ◆ _getProgramByName()

static GpuProgramPtr Ogre::GpuProgramUsage::_getProgramByName | ( | const String & | name,
|  | const String & | group,
|  | GpuProgramType | type
| ) |  |
| static

## ◆ preparingComplete()

virtual void Ogre::Resource::Listener::preparingComplete | ( | Resource * |  | ) |
| inline virtual inherited

Called whenever the resource finishes preparing (paging into memory).

Remarks
  If a Resource has been marked as background loaded (

See also
  Resource::setBackgroundLoaded) the call does not itself occur in the thread which is doing the preparing; when preparing is complete a response indicator is placed with the ResourceGroupManager, which will then be sent back to the listener as part of the application's primary frame loop thread.

The documentation for this class was generated from the following file:

- OgreGpuProgramUsage.h